import UIKit
import MetalKit

// Our iOS specific view controller
class GameViewController: UIViewController {

    var _renderer: VexilMain!
    var _mtkView: MTKView!

    override func viewDidLoad() {
        super.viewDidLoad()

        guard let _mtkView = view as? MTKView else {
            print("View of Gameview controller is not an MTKView")
            return
        }

        // Select the device to render with.  We choose the default device
        guard let defaultDevice = MTLCreateSystemDefaultDevice() else {
            print("Metal is not supported")
            return
        }
        
        _mtkView.device = defaultDevice
        _mtkView.backgroundColor = UIColor.clear

        guard let newRenderer = VexilMain(metalKitView: _mtkView) else {
            print("Renderer cannot be initialized")
            return
        }

        _renderer = newRenderer

        _renderer.mtkView(_mtkView, drawableSizeWillChange: _mtkView.drawableSize)

        _mtkView.delegate = _renderer
    }
	
	override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
		_renderer.touchesBegan(touches, with: event)
	}
	
	override func touchesMoved(_ touches: Set<UITouch>, with event: UIEvent?) {
		_renderer.touchesMoved(touches, with: event)
	}
	
	override func touchesEnded(_ touches: Set<UITouch>, with event: UIEvent?) {
		_renderer.touchesEnded(touches, with: event)
	}
}
